HDU 1506 Largest Rectangle in a Histogram (单调栈)

来源:互联网 发布:暮光女 出柜 知乎 编辑:程序博客网 时间:2024/05/29 14:50

Largest Rectangle in a Histogram

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 18711    Accepted Submission(s): 5592


Problem Description
A histogram is a polygon composed of a sequence of rectangles aligned at a common base line. The rectangles have equal widths but may have different heights. For example, the figure on the left shows the histogram that consists of rectangles with the heights 2, 1, 4, 5, 1, 3, 3, measured in units where 1 is the width of the rectangles:

Usually, histograms are used to represent discrete distributions, e.g., the frequencies of characters in texts. Note that the order of the rectangles, i.e., their heights, is important. Calculate the area of the largest rectangle in a histogram that is aligned at the common base line, too. The figure on the right shows the largest aligned rectangle for the depicted histogram.
 

Input
The input contains several test cases. Each test case describes a histogram and starts with an integer n, denoting the number of rectangles it is composed of. You may assume that 1 <= n <= 100000. Then follow n integers h1, ..., hn, where 0 <= hi <= 1000000000. These numbers denote the heights of the rectangles of the histogram in left-to-right order. The width of each rectangle is 1. A zero follows the input for the last test case.
 

Output
For each test case output on a single line the area of the largest rectangle in the specified histogram. Remember that this rectangle must be aligned at the common base line.
 

Sample Input
7 2 1 4 5 1 3 34 1000 1000 1000 10000
 

Sample Output
84000
 

Source

University of Ulm Local Contest 2003

题意:

找出最大的矩形面积。


point:


利用单调栈,维护一个单调上升栈,注意更新最左。比如栈里有1 2 5,后来来了一个4,4使5出栈,并且要使4的左端点变为原5的位置。

此为结构体里i的存在意义。(其实只要开一个数组记录就行了,做到后来的题才发现)


#include <iostream>#include <stdio.h>#include <string.h>#include <math.h>#include <stack>#define  ll long longusing namespace std;ll ans=0;struct node{    ll w;    int i;}a[100005];int main(){    int n;    while(~scanf("%d",&n)&&n)    {        ans=0;        for(int i=1;i<=n;i++)        {            scanf("%lld",&a[i].w);            a[i].i=i;        }        stack<node>q;        for(int i=1;i<=n;i++)        {            while(!q.empty()&&a[i].w<q.top().w)            {                node now=q.top();                    ans=max(ans,(i-now.i)*now.w);                    a[i].i=now.i;                    q.pop();            }                        q.push(a[i]);        }        while(!q.empty())        {            node now=q.top();            ans=max(ans,(n-now.i+1)*now.w);            q.pop();        }        printf("%lld\n",ans);            }}



阅读全文
0 0
原创粉丝点击